%        
%   ()  R(t)=exp{-[(t/tau)^2+i*w0*t]}, 
%  tau -  , w0=2*pi*f0-  .

%     
close all
%    (WORKSPACE)
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% T -   , 
T=1;
% tau -   , 
tau=0.20;
% f0 -  , 
f0=20;
% N -      
N=1024;
% K -    
K=20;

% dt -    
dt=T/N;
% df -    
df=1/(N*dt);
% t -      
t=(0:dt:T-dt)';
% f -   ,       
f=(-0.5/dt:df:0.5/dt-df)';
% R -      
R=exp(-(t(1:N/2+1)/tau).^2).*exp(-i*2*pi*f0*t(1:N/2+1));
R=[R; conj(R(N/2:-1:2))]; 
% Sp -     
Sp=abs(ifft(R));
R=[R(N/2+1:N); R(1:N/2)];

%     
figure(1)
plot(f,fftshift(Sp))
title('  ')
xlabel('f, ')
ylabel('S(f)')
grid

% Dp -        
Dp=sqrt(Sp)/sqrt(2);
Re=zeros(N,1);Ree=Re;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% M -      
M=N/2;
%      
for k=1:K
   % Ar, Ai -    . 
   Ar=randn(size(Dp(1:M)));Ai=randn(size(Dp(1:M)));
   % Aleft, Aright -     . 
   Aleft=Ar+i*Ai;
   Ar=randn(size(Dp(1:M)));Ai=randn(size(Dp(1:M)));
   Aright=Ar+i*Ai;
   % Aa -       
   Aa=[Aleft.*Dp(1:M); zeros(N-2*M,1); Aright.*Dp(N-M+1:N)];
   % S - k-   ,     FFT
   S=fft(Aa);

%   k-   
figure(2)
plot(t,[real(S) imag(S)]);
title(['  , k=' int2str(k)])
xlabel('t, ')
ylabel('s(t)')
grid
pause(1)

%      
Aa=Aa.*conj(Aa);
% Ree -    k-   
Ree=fft(Aa);
% Re - ,        
Re=Re+Ree;
end

Re=[Re(N/2+1:N); Re(1:N/2)];
%     
Re=Re./K;
% R       
R=[R Re];

%   : 
% -  ,  
% -  ,  
figure(3)
title(' :    ')
subplot(211);plot(t-0.5*T,real(R))
xlabel('\tau, c')
ylabel('Re\{R(\tau)\}')
grid
subplot(212);plot(t-0.5*T,imag(R))
xlabel('\tau, c')
ylabel('Im\{R(\tau)\}')
grid
